> This is a page from the ElevenLabs documentation. For a complete page index, fetch https://elevenlabs.io/docs/llms.txt. For the full documentation in a single file, fetch https://elevenlabs.io/docs/llms-full.txt.

# नियमों से उच्चारण शब्दकोश बनाएं

POST https://api.elevenlabs.io/v1/pronunciation-dictionaries/add-from-rules
Content-Type: application/json

दिए गए नियमों से नया उच्चारण शब्दकोश बनाता है।

Reference: https://elevenlabs.io/docs/api-reference/pronunciation-dictionaries/create-from-rules

## Servers

- `https://api.elevenlabs.io` (Production, default)
- `https://api.us.elevenlabs.io` (Production US)
- `https://api.eu.residency.elevenlabs.io` (Production EU)
- `https://api.in.residency.elevenlabs.io` (Production India)
- `https://api.sg.residency.elevenlabs.io` (Production Singapore)

## Request

### Body (application/json)

This endpoint expects a Body_Add_a_pronunciation_dictionary_v1_pronunciation_dictionaries_add_from_rules_post.

- `rules` (list of BodyAddAPronunciationDictionaryV1PronunciationDictionariesAddFromRulesPostRulesItems, required) — उच्चारण नियमों की सूची। नियम इनमें से कोई एक हो सकता है: एक उपनाम नियम: \{'string\_to\_replace': 'a', 'type': 'alias', 'alias': 'b', } या एक फ़ोनीम नियम: \{'string\_to\_replace': 'a', 'type': 'phoneme', 'phoneme': 'b', 'alphabet': 'ipa' }
- `name` (string, required) — उच्चारण डिक्शनरी का नाम, केवल पहचान के लिए इस्तेमाल किया जाता है।
- `description` (string, optional, nullable) — उच्चारण शब्दकोश का विवरण, केवल पहचान के लिए इस्तेमाल किया जाता है।
- `workspace_access` (enum, optional, nullable) — 'admin', 'editor' या 'viewer' में से एक होना चाहिए। न देने पर default रूप से access नहीं होगा।
  - Allowed values: `admin`, `editor`, `commenter`, `viewer`

## Response

### 200

सफल रिस्पॉन्स

- `id` (string, required) — बनाई गई उच्चारण डिक्शनरी की ID।
- `name` (string, required) — बनाई गई उच्चारण डिक्शनरी का नाम।
- `created_by` (string, required) — उच्चारण डिक्शनरी बनाने वाले की यूज़र ID।
- `creation_time_unix` (integer, required) — Unix टाइमस्टैम्प में उच्चारण शब्दकोश बनाने का समय।
- `version_id` (string, required) — बनाए गए उच्चारण डिक्शनरी वर्ज़न की ID।
- `version_rules_num` (integer, required) — उच्चारण शब्दकोश के इस वर्ज़न में नियमों की संख्या।
- `permission_on_resource` (enum, required, nullable) — उच्चारण शब्दकोश के रिसोर्स पर अनुमति।
  - Allowed values: `admin`, `editor`, `commenter`, `viewer`
- `description` (string, optional, nullable) — उच्चारण शब्दकोश का विवरण।

## Errors

### 422 Unprocessable Entity Error

वैलिडेशन एरर

- `detail` (list of ValidationError, optional)

## Types

### BodyAddAPronunciationDictionaryV1PronunciationDictionariesAddFromRulesPostRulesItems

### ValidationError

- `loc` (list of ValidationErrorLocItems, required)
- `msg` (string, required)
- `type` (string, required)

### PronunciationDictionaryAliasRuleRequestModel

- `string_to_replace` (string, required) — बदलने वाली स्ट्रिंग। यह खाली नहीं होनी चाहिए।
- `type` ("alias", required) — नियम का टाइप।
- `alias` (string, required) — बदली जाने वाली स्ट्रिंग का एलियस।
- `case_sensitive` (boolean, optional, default: true) — क्या rule को case-sensitive रूप से मैच करना चाहिए।
- `word_boundaries` (boolean, optional, default: true) — क्या rule को केवल शब्द सीमाओं पर मैच करना चाहिए।

### PronunciationDictionaryPhonemeRuleRequestModel

- `string_to_replace` (string, required) — बदलने वाली स्ट्रिंग। यह खाली नहीं होनी चाहिए।
- `type` ("phoneme", required) — नियम का टाइप।
- `phoneme` (string, required) — फ़ोनीम नियम।
- `alphabet` (string, required) — फ़ोनीम नियम के साथ इस्तेमाल करने वाली अल्फ़ाबेट।
- `case_sensitive` (boolean, optional, default: true) — क्या rule को case-sensitive रूप से मैच करना चाहिए।
- `word_boundaries` (boolean, optional, default: true) — क्या rule को केवल शब्द सीमाओं पर मैच करना चाहिए।

### ValidationErrorLocItems

## Examples

**Request**

```json
{
  "rules": [
    {
      "alias": "string",
      "string_to_replace": "string",
      "type": "string"
    }
  ],
  "name": "My Dictionary"
}
```

**Response**

```json
{
  "id": "5xM3yVvZQKV0EfqQpLrJ",
  "name": "My Dictionary",
  "created_by": "ar6633Es2kUjFXBdR1iVc9ztsXl1",
  "creation_time_unix": 1714156800,
  "version_id": "5xM3yVvZQKV0EfqQpLrJ",
  "version_rules_num": 5,
  "permission_on_resource": "admin",
  "description": "This is a test dictionary"
}
```

**SDK Code**

```python
import requests

url = "https://api.elevenlabs.io/v1/pronunciation-dictionaries/add-from-rules"

payload = {
    "rules": [
        {
            "alias": "string",
            "string_to_replace": "string",
            "type": "string"
        }
    ],
    "name": "My Dictionary"
}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.elevenlabs.io/v1/pronunciation-dictionaries/add-from-rules';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"rules":[{"alias":"string","string_to_replace":"string","type":"string"}],"name":"My Dictionary"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.elevenlabs.io/v1/pronunciation-dictionaries/add-from-rules"

	payload := strings.NewReader("{\n  \"rules\": [\n    {\n      \"alias\": \"string\",\n      \"string_to_replace\": \"string\",\n      \"type\": \"string\"\n    }\n  ],\n  \"name\": \"My Dictionary\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.elevenlabs.io/v1/pronunciation-dictionaries/add-from-rules")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"rules\": [\n    {\n      \"alias\": \"string\",\n      \"string_to_replace\": \"string\",\n      \"type\": \"string\"\n    }\n  ],\n  \"name\": \"My Dictionary\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.elevenlabs.io/v1/pronunciation-dictionaries/add-from-rules")
  .header("Content-Type", "application/json")
  .body("{\n  \"rules\": [\n    {\n      \"alias\": \"string\",\n      \"string_to_replace\": \"string\",\n      \"type\": \"string\"\n    }\n  ],\n  \"name\": \"My Dictionary\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.elevenlabs.io/v1/pronunciation-dictionaries/add-from-rules', [
  'body' => '{
  "rules": [
    {
      "alias": "string",
      "string_to_replace": "string",
      "type": "string"
    }
  ],
  "name": "My Dictionary"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.elevenlabs.io/v1/pronunciation-dictionaries/add-from-rules");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"rules\": [\n    {\n      \"alias\": \"string\",\n      \"string_to_replace\": \"string\",\n      \"type\": \"string\"\n    }\n  ],\n  \"name\": \"My Dictionary\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [
  "rules": [
    [
      "alias": "string",
      "string_to_replace": "string",
      "type": "string"
    ]
  ],
  "name": "My Dictionary"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.elevenlabs.io/v1/pronunciation-dictionaries/add-from-rules")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```